Lattice Grid Buy a licence

demo D308

A figure at every site, on a map in Angular

One marker per location carrying its own formatted figure, coloured by the same rule that colours the cell, so an availability wall is one rule set and one chart

type: 'markermap', lon, lat, label, value

A dozen data centres on one map, each carrying its own availability figure and coloured by the promise it is keeping. Filter or sort the table beneath and the map follows, because both are reading the same rows.

Building…
Loading a live grid…

This is the Angular version. A standalone component takes the whole configuration through one config input, surfaces grid events as outputs, and exposes the live grid on a getter for anything the inputs do not cover.

The configuration

import { Component, ViewChild, AfterViewInit } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { createChart } from '@toclocoinc/lattice-grid/modules/charts';
import { pack } from '@toclocoinc/lattice-grid/modules/geo-world-110m';
import '@toclocoinc/lattice-grid/modules/chart-markermap';  // opt in to the markermap type
import { LatticeGridComponent, provideLattice } from '@toclocoinc/lattice-grid/angular';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template:
    '<lattice-grid [config]="gridConfig" style="display:block;height:300px"></lattice-grid>' +
    '<div id="chart" style="height:380px;margin-top:12px"></div>',
})
export class AppComponent implements AfterViewInit {
  @ViewChild(LatticeGridComponent) gridRef!: LatticeGridComponent;

  gridConfig = {
    rowKey: 'id',
    selection: 'multiple',
    formatting: {
      availability: [
        { id: 'met', label: 'Meeting the promise', when: { op: 'gte', value: 0.999 }, style: { background: '#1a7f37', color: '#fff' } },
        { id: 'watch', label: 'Watch', when: { op: 'gte', value: 0.995 }, style: { background: '#b26a00', color: '#fff' } },
        { id: 'breached', label: 'Below the promise', when: { op: 'lt', value: 0.995 }, style: { background: '#c02c38', color: '#fff' } },
      ],
    },
    columns: [
      { field: 'site', title: 'Site', layout: { pin: 'start', width: 110 } },
      { field: 'region', title: 'Region', filter: { type: 'set' } },
      { field: 'availability', title: 'Availability', type: 'number', format: '0.00%', filter: { type: 'number' } },
    ],
    rows: [/* sites: id, site, region, lon, lat, availability */],
  };

  ngAfterViewInit() {
    createChart({
      grid: this.gridRef.grid, container: '#chart', type: 'markermap',
      lon: 'lon', lat: 'lat', label: 'site', value: 'availability',
      shapes: pack, selection: true, title: 'Availability, site by site',
    });
  }
}

bootstrapApplication(AppComponent, {
  providers: [provideLattice({ createGrid })],
});

An availability wall from one set of rules

A status map usually costs twice: once to colour the table, and again to colour the map, with two sets of thresholds that drift apart until a cell says amber and the dot beside it says green.

Here the rules live on the availability column, and both readings come from them. The figure printed beside each dot is the column’s own cell text, so a percentage reads as a percentage, an amount of money reads as money, and a unit reads as its unit, with the decimals you already chose. The fill is whatever rule that value matched. Change a cut point once and the table and the map both move, because there is only one place to change it.

The legend names the rules that actually matched, with each rule’s own label and swatch, so it reads as your policy rather than as a palette.

The map is a view of the grid, not a copy of it

Narrow the table to one region and the map redraws to that region. Sort it, edit a reading, point the grid at a live feed: the markers follow, the same way every other chart here does. Click a marker and its row is selected in the table below, so a dot on the other side of the world and the line of detail behind it are one gesture apart.

Sites whose coordinates are missing or out of range are counted and reported rather than quietly left off, so a map that is showing you eleven of twelve sites says so.

How do I put a value from my grid on a map?

Load the marker map type beside the charts module and call createChart({ grid, container, type: 'markermap', lon, lat, label, value }), where lon and lat are the columns holding degrees and value is the column whose figure and colour you want on the map. Pass a geometry pack as shapes to draw real boundaries underneath, in that pack’s own projection, with the pan and zoom a country map has. Add selection: true to tie a click on a marker to its row, and labels: false on a dense map to leave the detail to the tooltip.

Lattice Grid Buy a licence

demo D308

A figure at every site, on a map in React

One marker per location carrying its own formatted figure, coloured by the same rule that colours the cell, so an availability wall is one rule set and one chart

type: 'markermap', lon, lat, label, value

A dozen data centres on one map, each carrying its own availability figure and coloured by the promise it is keeping. Filter or sort the table beneath and the map follows, because both are reading the same rows.

Building…
Loading a live grid…

This is the React version. The grid mounts through the createLatticeGrid adapter, which takes its configuration as ordinary props and hands back the live grid through a ref. The grid below is the same one every other tab runs.

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/lattice-grid.min.css">

<div id="app"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/lattice-grid.esm.min.js';
  import { createLatticeReact } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/modules/react.esm.min.js';
  import { createChart } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/modules/charts.esm.min.js';
  import { pack } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/modules/geo-world-110m.esm.min.js';
  import 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/modules/chart-markermap.esm.min.js';  // opt in to the markermap type

  const { LatticeGrid, LatticeChart } = createLatticeReact({ React, createGrid, createChart });

  const availabilityRules = [
    { id: 'met', label: 'Meeting the promise', when: { op: 'gte', value: 0.999 }, style: { background: '#1a7f37', color: '#fff' } },
    { id: 'watch', label: 'Watch', when: { op: 'gte', value: 0.995 }, style: { background: '#b26a00', color: '#fff' } },
    { id: 'breached', label: 'Below the promise', when: { op: 'lt', value: 0.995 }, style: { background: '#c02c38', color: '#fff' } },
  ];
  const columns = [
    { field: 'site', title: 'Site', layout: { pin: 'start', width: 110 } },
    { field: 'region', title: 'Region', filter: { type: 'set' } },
    { field: 'availability', title: 'Availability', type: 'number', format: '0.00%', filter: { type: 'number' } },
  ];
  const rows = [/* sites: id, site, region, lon, lat, availability */];

  function App() {
    const [grid, setGrid] = React.useState(null);

    return (
      <>
        <LatticeGrid rowKey="id" selection="multiple" formatting={{ availability: availabilityRules }} columns={columns} rows={rows} onGridReady={setGrid} style={{ height: '300px' }} />
        {/* One marker per site, where the site is; selection is shared both ways. */}
        {grid && (
          <LatticeChart grid={grid} type="markermap" lon="lon" lat="lat" label="site" value="availability" shapes={pack} selection title="Availability, site by site" style={{ height: '380px', marginTop: '12px' }} />
        )}
      </>
    );
  }

  createRoot(document.getElementById('app')).render(<App />);
</script>

An availability wall from one set of rules

A status map usually costs twice: once to colour the table, and again to colour the map, with two sets of thresholds that drift apart until a cell says amber and the dot beside it says green.

Here the rules live on the availability column, and both readings come from them. The figure printed beside each dot is the column’s own cell text, so a percentage reads as a percentage, an amount of money reads as money, and a unit reads as its unit, with the decimals you already chose. The fill is whatever rule that value matched. Change a cut point once and the table and the map both move, because there is only one place to change it.

The legend names the rules that actually matched, with each rule’s own label and swatch, so it reads as your policy rather than as a palette.

The map is a view of the grid, not a copy of it

Narrow the table to one region and the map redraws to that region. Sort it, edit a reading, point the grid at a live feed: the markers follow, the same way every other chart here does. Click a marker and its row is selected in the table below, so a dot on the other side of the world and the line of detail behind it are one gesture apart.

Sites whose coordinates are missing or out of range are counted and reported rather than quietly left off, so a map that is showing you eleven of twelve sites says so.

How do I put a value from my grid on a map?

Load the marker map type beside the charts module and call createChart({ grid, container, type: 'markermap', lon, lat, label, value }), where lon and lat are the columns holding degrees and value is the column whose figure and colour you want on the map. Pass a geometry pack as shapes to draw real boundaries underneath, in that pack’s own projection, with the pan and zoom a country map has. Add selection: true to tie a click on a marker to its row, and labels: false on a dense map to leave the detail to the tooltip.